#include <stdbool.h>
// AVAILABLE CHECK TYPES
//    PICOTEST_ASSERT(check1);
//    PICOTEST_VERIFY(0, "BETA");
//    PICOTEST_ABORT();

PICOTEST_SUITE(mainSuite, TEXT_SANITY_TESTS, TEXT_STAT_TESTS)

unsigned int *TextFileStats(char *filename);

bool verifyTextFileStats(char *fileNameBase) {
    char path[1024];
    sprintf(path, "../textfiles/%s.txt", fileNameBase);
    FILE *F = fopen(path, "r");printf("%s %p\n\n", path, F);fclose(F);
    unsigned int *statistics = TextFileStats(path);
    if (statistics == NULL) {
        return false;
    }
    unsigned int sum = 0;
//    printf("%s\n", fileNameBase);
    for (int i = 0; i < 129; ++i) {
        sum += statistics[i];
//        printf("%d,", statistics[i]);
//        if (statistics[i] == 0) {
//            printf("%c (%d) => %d\n", i, i, statistics[i]);
//        }
    }
//    printf("\n\n");
//    printf("%s %d\n", fileNameBase, sum);
    if (strcmp(fileNameBase, "ascii-art")==0) {
        unsigned int correct[] = {
            0,0,0,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1451,1,20,3,
            1,1,2,3,2,2,3,3,99,1040,100,29,3,4,3,3,3,3,3,3,3,3,98,99,6,17,4,2,1,3,1,3,5,4,
            12,1,3,4,1,3,2,1,1,2,2,1,2,3,1,1,81,2,1,1,1,1,5,3,3,295,33,1,0,2,0,4,0,0,0,17,
            17,1,6,0,2,1,2,0,2,3,5,0,1,0,0,0,1,1,743,1,1,0,14
        };
        for (int i = 0; i < 129; ++i) {
            if (correct[i] != statistics[i]) {
                printf("File %s has at code %c (%d) value %d instead of %d\n",
                        fileNameBase, i, i, statistics[i], correct[i]);
                return false;
            }
        }
        if (sum != 4351) {
            return false;
        }
    } else if (strcmp(fileNameBase, "google-translate-failure")==0) {
        unsigned int correct[] = {
                0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,121,
                4,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,2,2,0,0,0,0,0,0,0,16,4,0,0,0,4,0,4,3,
                0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,2,1,0,0,4,0,0,0,0,0,0,0,0,0,26,4,8,13,
                32,3,2,19,9,0,5,4,5,9,15,2,0,9,17,21,8,0,6,0,9,0,0,0,0,0,0,595
        };
        for (int i = 0; i < 129; ++i) {
            if (correct[i] != statistics[i]) {
                printf("File %s has at code %c (%d) value %d instead of %d\n",
                       fileNameBase, i, i, statistics[i], correct[i]);
                return false;
            }
        }
        if (sum != 1013) {
            return false;
        }
    } else if (strcmp(fileNameBase, "mech-eng")==0) {
        unsigned int correct[] = {
                0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,130,
                1,0,0,0,0,0,1,0,0,0,0,7,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,
                0,3,0,2,1,0,0,0,0,4,2,1,0,0,0,3,4,2,0,2,0,0,0,0,0,0,0,0,0,76,10,43,31,
                103,17,22,35,67,0,1,37,15,75,62,14,2,42,44,70,20,13,4,1,10,1,0,0,0,0,0,0
        };
        for (int i = 0; i < 129; ++i) {
            if (correct[i] != statistics[i]) {
                printf("File %s has at code %c (%d) value %d instead of %d\n",
                       fileNameBase, i, i, statistics[i], correct[i]);
                return false;
            }
        }
        if (sum != 1003) {
            return false;
        }
    } else if (strcmp(fileNameBase, "star-wars")==0) {
        unsigned int correct[] = {
                0,0,0,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,342,
                0,8,0,0,0,0,6,4,4,0,0,28,7,14,0,1,3,0,0,0,1,1,1,1,1,2,1,0,0,0,0,0,2,1,
                0,4,1,7,0,1,3,3,1,1,0,0,0,0,0,1,6,6,0,0,2,0,0,0,8,0,8,0,0,0,153,26,65,
                65,228,38,49,103,127,1,9,73,39,117,109,36,0,121,119,160,45,12,31,6,37,
                1,0,0,0,0,0,0
        };
        for (int i = 0; i < 129; ++i) {
            if (correct[i] != statistics[i]) {
                printf("File %s has at code %c (%d) value %d instead of %d\n",
                       fileNameBase, i, i, statistics[i], correct[i]);
                return false;
            }
        }
        if (sum != 2275) {
            return false;
        }
    } else if (strcmp(fileNameBase, "alphabet")==0) {
        unsigned int correct[] = {
                0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,
                1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,
                1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0
        };
        for (int i = 0; i < 129; ++i) {
            if (correct[i] != statistics[i]) {
                printf("File %s has at code %c (%d) value %d instead of %d\n",
                       fileNameBase, i, i, statistics[i], correct[i]);
                return false;
            }
        }
        for (int i = 0; i < 129; ++i) {
            if (
                    ('a'<=i && i<='z') ||
                    ('A'<=i && i<='Z') ||
                    ('0'<=i && i<='9')
               ) {
                if (statistics[i] != 1) {
                    printf("File %s at position %c (%d) stat is %d\n", fileNameBase, i, i, statistics[i]);
                    return false;
                }
            } else {
                if (statistics[i] != 0) {
                    printf("File %s at position %c (%d) stat is %d\n", fileNameBase, i, i, statistics[i]);
                    return false;
                }
            }
        }
        if (sum != 62) {
            return false;
        }
    } else {
        printf("Unknown file base : %s\n", fileNameBase);
        return false;
    }
    return true;
}

PICOTEST_CASE(TEXT_SANITY_TESTS) {
    PICOTEST_VERIFY(TextFileStats(NULL) == NULL, "NULL filename NOT detected!");
    PICOTEST_VERIFY(TextFileStats("") == NULL, "Empty \"\" filename NOT detected!");
    PICOTEST_VERIFY(TextFileStats("owehfiwuehfiwueh.opa") == NULL, "Inexistent file NOT detected!");
}

PICOTEST_CASE(TEXT_STAT_TESTS) {
    PICOTEST_VERIFY(verifyTextFileStats("ascii-art"), "Bad result");
    PICOTEST_VERIFY(verifyTextFileStats("google-translate-failure"), "Bad result");
    PICOTEST_VERIFY(verifyTextFileStats("mech-eng"), "Bad result");
    PICOTEST_VERIFY(verifyTextFileStats("star-wars"), "Bad result");
    PICOTEST_VERIFY(verifyTextFileStats("alphabet"), "Bad result");
}


//PICOTEST_SUITE(mainSuite, RANGE_TESTS, BOUNDARY_TESTS)
//
//PICOTEST_CASE(RANGE_TESTS) {
//    int v5in1_2 = !isInRange(5, 1, 2);
//    PICOTEST_VERIFY(v5in1_2, "isInRange(5,1,2) returns unexpected result!");
//    int v5in1_8 = isInRange(5, 1, 8);
//    PICOTEST_VERIFY(v5in1_8, "isInRange(5,1,8) returns unexpected result!");
//}
//PICOTEST_CASE(BOUNDARY_TESTS) {
//    int v5in1_5 = isInRange(5,1,5);
//    PICOTEST_VERIFY(v5in1_5, "isInRange(5,1,5) returns unexpected result!");
//    int v1in1_5 = isInRange(1,1,5);
//    PICOTEST_VERIFY(v5in1_5, "isInRange(1,1,5) returns unexpected result!");
//}
//PICOTEST_CASE(aktina_0) {
//}
//PICOTEST_CASE(aktina_PI) {
//}
